#include "main.h"

bool sUART::Init(unsigned char _port,unsigned long _baud)
{
 	DWord	baudrate;
	baudrate.ulong=_baud;
	baudrate.ulong=((F_CPU/16)/_baud)-1;

	if (_port==UART0)
	{
		UBRR0H = baudrate.Words.Low.Bytes.High.uchar;
		UBRR0L = baudrate.Words.Low.Bytes.Low.uchar;
		UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
		UCSR0C = (3<<UCSZ00);
	}
	else if (_port==UART1)
	{
		UBRR1H = baudrate.Words.Low.Bytes.High.uchar;
		UBRR1L = baudrate.Words.Low.Bytes.Low.uchar;
		UCSR1B = (1<<RXEN1)|(1<<TXEN1)|(1<<RXCIE1);
		UCSR1C = (3<<UCSZ10);
	}
	else 
		return false;
	port=_port;
	baud=_baud;
	return true;
}
void sUART::Write(unsigned char* data_src, unsigned int size)
{
    unsigned int i=0;
    if (size==0)
    {
      while(data_src[i])
	SendByte(data_src[i++]); 
    }
    else
    {
      while (i<size)
	SendByte(data_src[i++]);  
    }
}

bool sUART::Read (unsigned char* data_dest, unsigned int size)
{
	return true;
}
bool sUART::SendByte (unsigned char byte)
{
	if (port==UART0)
	{
		 while ( !( UCSR0A & (1<<UDRE0)) )
		 ;
		 UDR0 = byte;
	}
	else if (port==UART1)
	{
	         while ( !( UCSR1A & (1<<UDRE1)) )
		 ;
		 UDR1 = byte;
	}
	else 
		return false;
        return true;
}

