#include "main.h"

typedef OS::process<OS::pr0, 128, 32>   tOutput_Task;
typedef OS::process<OS::pr1, 128, 32>   tUART0_Task;
typedef OS::process<OS::pr2, 128, 32>   tUART1_Task;
typedef OS::process<OS::pr3, 128, 32>   tMeas_Task;
typedef OS::process<OS::pr4, 32, 32>    tKBD_Task;

tOutput_Task            Output_Task;
tUART0_Task             UART0_Task;
tUART1_Task             UART1_Task;
tMeas_Task              Meas_Task;
tKBD_Task               KBD_Task;

OS::TEventFlag      	keypress_flag;
OS::TMutex          	SPI_ready,TWI_ready;

sUART 					UART_0,UART_1;

void main(void)
{
    DDRG  |= (1<<0);
    PORTG &= ~(1<<0);
        
    UART_0.Init(UART0,9600);
    UART_0.Write("/*---- RESET -----*/\n\r");
    
    OS::Run();
    while(1);
}

template<> void tOutput_Task::Exec()
{
    for(;;)
    {
        UART_0.Write("output task\n\r");
        Sleep (100);
        UART_0.Write("output task is back\n\r");
    }
}

template<> void tUART0_Task::Exec()
{
    for(;;)
    {
        UART_0.Write("uart0 task\n\r");
        Sleep (100);
    }
}

template<> void tUART1_Task::Exec()
{
    for(;;)
    {
        UART_0.Write("uart1 task\n\r");
        Sleep (100);
    }
}

template<> void tMeas_Task::Exec()
{
    for(;;)
    {
        UART_0.Write("measure task\n\r");
        Sleep (100);
    }
}

template<> void tKBD_Task::Exec()
{
    for(;;)
    {
        UART_0.Write("keyboard task\n\r");
        Sleep (100);
    }
}

void OS::SystemTimerUserHook() { }
void OS::IdleProcessUserHook() 
{
    PORTG^= (1<<0); 
    __delay_cycles (F_CPU/16);
}


